unit maingrid;

{******************************************************************************}
{                                                                              }
{                           IMPORTANT NOTICE                                   }
{                                                                              }
{              (c) Copyright 2001 by Alirio A. Gavidia B.                      }
{                                                                              }
{                         ALL RIGHTS RESERVED                                  }
{                                                                              }
{                                                                              }
{       Portions may be Copyright (c) 1995 Borland International.              }
{       All restriction apply.                                                 }
{******************************************************************************}
{******************************************************************************}
{  Version 1.0.0  02-Jun-2000                                                  }
{  Version 2.0.0  09-Ago-2000                                                  }
{                                                                              }
{  by Alirio A. Gavidia B.     email:   alirio@gavidia.org                     }
{                                                                              }
{******************************************************************************}



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, HalCustomExpr, HalSimpleExpr, ExtCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    HalSimpleExpr1: THalSimpleExpr;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure HalSimpleExpr1RequestFunction(Sender: TObject;
      ident: String; var value: Variant; var cancel: Boolean);
    procedure HalSimpleExpr1RequestIdentifier(Sender: TObject; ident,
      alias: String; var value: Variant; var cancel: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
StringGrid1.RowCount := 4;
StringGrid1.ColCount := 4;

StringGrid1.Cells[0,1] := '1';
StringGrid1.Cells[0,2] := '2';
StringGrid1.Cells[0,3] := 'Total';

StringGrid1.Cells[1,0] := 'A';
StringGrid1.Cells[2,0] := 'B';
StringGrid1.Cells[3,0] := 'Total';


StringGrid1.Cells[1,1] := '1';
StringGrid1.Cells[2,1] := '2';
StringGrid1.Cells[1,2] := '3';
StringGrid1.Cells[2,2] := '4';

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
// Using brackets the expression is solved using onRequestIdentifier.
// Using parenthesis the expression is solved using onRequestFunction.

  StringGrid1.Cells[3,1] := IntToStr( HalSimpleExpr1.EvalInteger('Cell[1,1] + Cell[2,1]')); // <-- Using brackets
  StringGrid1.Cells[3,2] := IntToStr( HalSimpleExpr1.EvalInteger('Cell(1,2) + Cell(2,2)')); // <-- Parenthesis

  StringGrid1.Cells[1,3] := IntToStr( HalSimpleExpr1.EvalInteger('Cell(1,1) + Cell(1,2)'));
  StringGrid1.Cells[2,3] := IntToStr( HalSimpleExpr1.EvalInteger('Cell(2,1) + Cell(2,2)'));

  StringGrid1.Cells[3,3] := IntToStr( HalSimpleExpr1.EvalInteger('Cell(2,1) + Cell(2,2) + Cell(1,1) + Cell(1,2)'))

end;

procedure TForm1.HalSimpleExpr1RequestFunction(Sender: TObject;
  ident: String;  var value: Variant; var cancel: Boolean);
Var
  col, row : integer;
begin
  if CompareText(ident,'Cell')=0 then
    begin
      col := (Sender as THalSimpleExpr).ArgVal[0];
      row := (Sender as THalSimpleExpr).ArgVal[1];
      value := StrToFloat(StringGrid1.Cells[col,row])
    end
  else
    cancel := true
end;

procedure TForm1.HalSimpleExpr1RequestIdentifier(Sender: TObject; ident,
  alias: String; var value: Variant; var cancel: Boolean);
Var
  col, row : integer;
begin
  if CompareText(ident,'Cell')=0 then
    begin
      col := (Sender as THalSimpleExpr).ArgVal[0];
      row := (Sender as THalSimpleExpr).ArgVal[1];
      value := StrToFloat(StringGrid1.Cells[col,row])
    end
  else
    cancel := true
end;

end.
