unit mainMacro;

{******************************************************************************}
{                                                                              }
{                           IMPORTANT NOTICE                                   }
{                                                                              }
{              (c) Copyright 2001 by Alirio A. Gavidia B.                      }
{                                                                              }
{                         ALL RIGHTS RESERVED                                  }
{                                                                              }
{                                                                              }
{       Portions may be Copyright (c) 1995 Borland International.              }
{       All restriction apply.                                                 }
{******************************************************************************}
{******************************************************************************}
{  Version 1.0.0  02-Jun-2000                                                  }
{  Version 2.0.0  09-Ago-2000                                                  }
{                                                                              }
{  by Alirio A. Gavidia B.     email:   alirio@gavidia.org                     }
{                                                                              }
{******************************************************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HalMacroExpr, StdCtrls, Db, Grids, DBGrids, DBTables, Buttons, ExtCtrls,
  HalSimpleExpr, HalCustomExpr, Spin, HalArithmeticExpr;

type
  Tfmain = class(TForm)
    Tbbiolife: TTable;
    DataSource1: TDataSource;
    Panel1: TPanel;
    Label1: TLabel;
    EdtExpr: TEdit;
    BtnEval: TBitBtn;
    LblResult: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    ListBox1: TListBox;
    Panel3: TPanel;
    Label3: TLabel;
    DBGrid1: TDBGrid;
    Macro: THalMacroExpr;
    LblDateFormat: TLabel;
    LblEpoch: TLabel;
    CmbDateFormat: TComboBox;
    spnEpoch: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure BtnEvalClick(Sender: TObject);
    procedure Panel3Resize(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure MacroRequestFunction(Sender: TObject; ident: String;
      var value: Variant; var cancel: Boolean);
    procedure MacroRequestIdentifier(Sender: TObject; ident, alias: String;
      var value: Variant; var cancel: Boolean);
    procedure spnEpochChange(Sender: TObject);
    procedure CmbDateFormatChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmain: Tfmain;

implementation

{$R *.DFM}

procedure Tfmain.FormCreate(Sender: TObject);
begin
  Tbbiolife.open;
  Macro.DataSetList.AddDataset('biolife',Tbbiolife);

  CmbDateFormat.ItemIndex := Ord(macro.DateFormat);
  spnEpoch.Value := macro.DateEpoch;
end;

procedure Tfmain.FormDestroy(Sender: TObject);
begin
  Tbbiolife.close;
end;

procedure Tfmain.ListBox1DblClick(Sender: TObject);
begin
  if ListBox1.ItemIndex>=0 then
    EdtExpr.text := ListBox1.Items[ListBox1.ItemIndex]
  else
    EdtExpr.text := ''
end;

procedure Tfmain.BtnEvalClick(Sender: TObject);
begin
  lblResult.Caption  := 'Resultado: ' + Macro.EvalString(EdtExpr.text)
end;

procedure Tfmain.Panel3Resize(Sender: TObject);
begin
  DBGrid1.Width := Panel3.Width - 20;
  DBGrid1.Height := Panel3.Height - (258-217)
end;

procedure Tfmain.Panel2Resize(Sender: TObject);
begin
  ListBox1.Height := Panel2.Height - (258-113) ;
  LblDateFormat.Top := Panel2.Height - (260 - 160);
  LblEpoch.Top := Panel2.Height - (260 - 200);
  CmbDateFormat.Top := Panel2.Height - (260 - 176);
  spnEpoch.Top := Panel2.Height - (260 - 216);

end;

procedure Tfmain.MacroRequestFunction(Sender: TObject; ident: String;
  var value: Variant; var cancel: Boolean);
begin
  MessageDlg('mainMacro: Funcin no hallada ('+ident+')', mtError, [mbOK], 0);
end;

procedure Tfmain.MacroRequestIdentifier(Sender: TObject; ident, alias: String;
  var value: Variant; var cancel: Boolean);
begin
if CompareText(ident,'pi')=0 then
  value := pi
else
  cancel := true
end;

procedure Tfmain.spnEpochChange(Sender: TObject);
Var
  n : integer;
begin
  try
    n := spnEpoch.Value
  except
    n := 0
  end;
  if (n>=0) and (n<=99) then
    macro.DateEpoch := n
end;

procedure Tfmain.CmbDateFormatChange(Sender: TObject);
begin
  macro.DateFormat := TDateFormat(CmbDateFormat.ItemIndex);
end;

end.
