unit maintest;

{******************************************************************************}
{                                                                              }
{                           IMPORTANT NOTICE                                   }
{                                                                              }
{              (c) Copyright 2001 by Alirio A. Gavidia B.                      }
{                                                                              }
{                         ALL RIGHTS RESERVED                                  }
{                                                                              }
{                                                                              }
{       Portions may be Copyright (c) 1995 Borland International.              }
{       All restriction apply.                                                 }
{******************************************************************************}
{******************************************************************************}
{  Version 1.0.0  02-Jun-2000                                                  }
{  Version 2.0.0  09-Ago-2000                                                  }
{                                                                              }
{  by Alirio A. Gavidia B.     email:   alirio@gavidia.org                     }
{                                                                              }
{******************************************************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IdentList, Grids, DBGrids, Db, DBTables, HalsimpleExpr,
  HalCustomExpr, ExtCtrls;


// Example of TExpression, TIndentList and TfuncList
// Table used : country (DBDemos)

// TExpression let us to evaluate expressions under xBase syntax.
// Without variables or constans
// all is simple, like this:
//
//    Expr := TExpression.Create;
//    lblResult.Caption := 'Result:' + Expr.EvalString(Edit1.Text);
//    Expr.free
//
//  Or, if you prefere:
//
//    Expr.Expression :=  Edit1.Text;
//    Expr.Prepare;
//    Expr.Process;
//    lblResult.Caption := 'Result:' + VarAsType(Expr.ResVal,VarString);
//
//  The second way is usefull in loops because Prepare only must be executed
//  when the expression change.
//
//  OnRequestIdentifier asociate identifiers and his values.
//
//     Expr.OnRequestIdentifier := ReqIndent;
//
//
//    procedure TfTest.ReqIndent(ident: string; var value: variant; var cancel : boolean);
//    begin
//      if UpperCase(Ident)='PI' then
//        value := Pi
//      else if UpperCase(Ident)='E' then
//        value := ln(1)
//      else if UpperCase(Ident)='X' then
//        value := 'Ser o no ser'
//      else
//        begin
//          value := 0;
//          cancel := true
//        end;
//    end;
//
//
//   For haig quantity of identifiers consider to use TidentList and TfuncList
//
//
//   procedure TfTest.ReqIndent(ident: string; var value: variant; var cancel : boolean);
//    begin
//      if not IdLst.GetIdentValue(ident, value) then
//        cancel := true;
//    end;
//
//
//
//    procedure TfTest.ReqFunc(ident: string; var value: variant; var cancel : boolean);
//    var
//      posi : integer;
//    begin
//      posi :=  FnLst.GetFuncPos(ident);
//      if posi>=0 then
//        value := FnLst.FuncArray[posi]
//      else
//        cancel := true;
//    end;


type
  TfTest = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Expr: THalSimpleExpr;
    Panel1: TPanel;
    Label1: TLabel;
    LblResult: TLabel;
    LblStatus: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    btnEvalua: TButton;
    Panel2: TPanel;
    Label3: TLabel;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnEvaluaClick(Sender: TObject);
    procedure ExprRequestFunction(Sender: TObject; ident: String; var value: Variant;
      var cancel: Boolean);
    procedure ExprRequestIdentifier(Sender: TObject; ident, alias: String;
      var value: Variant; var cancel: Boolean);
  private
    { Private declarations }
    IdLst : THalIdentList;
    FnLst : THalfuncList;
    DataSetLst : THalDataSetList;
    function AllTrim(Sender: TObject): variant;
    function Date(Sender: TObject): variant;
    function at(Sender: TObject): variant;
    function iif(Sender: TObject): variant;
    function len(Sender: TObject): variant;
    function time(Sender: TObject): variant;
  end;

var
  fTest: TfTest;

implementation

{$R *.DFM}

// Show data type

function typetostr(t : integer) : string;
begin
    Case t of
    0 : result :=  'Indefinido';
    1 : result :=  'Entero';
    2 : result :=  'Doble';
    3 : result :=  'string';
    4 : result :=  'Fecha';
    5 : result :=  'identificador';
    6 : result :=  'Operador';
    7 : result :=  'Funcin';
    else
      result :=  'No definido';
    end;
end;

procedure TfTest.FormCreate(Sender: TObject);
begin
  Table1.Open;

  IdLst := THalIdentList.Create;   // Identifiers list
  DataSetLst := THalDataSetList.Create;  // Datasets list.
  FnLst := THalfuncList.Create; // function list.

// Until 500 indetifiers without problems
// pass this point EstimatedSize must be redefined (default 512).

  IdLst.EstimatedSize := 500;  // Don't bother the minimal is 500.

  IdLst.AddIdent('pi',pi);
  IdLst.AddIdent('e',exp(1));

  FnLst.EstimatedSize := 500;
  FnLst.AddIdent('alltrim', AllTrim); // notese que trim y alltrim
  FnLst.AddIdent('trim', AllTrim);    // son lo mismo
  FnLst.AddIdent('date', date);
  FnLst.AddIdent('at', at);
  FnLst.AddIdent('time', time);
  FnLst.AddIdent('if', iif);
  FnLst.AddIdent('iif', iif);
  FnLst.AddIdent('len', len);

  DataSetLst.AddDataset('country',Table1);
end;


procedure TfTest.FormDestroy(Sender: TObject);
begin
  Table1.Close;
  IdLst.Free;
  FnLst.Free;
  DataSetLst.Free;
end;

procedure TfTest.btnEvaluaClick(Sender: TObject);
begin
  try
   lblResult.Caption := 'Result:' + Expr.EvalString(Edit1.Text);
   lblStatus.Caption := 'type: ' + typetostr(Expr.ResTyp);
  except
   lblStatus.Caption := 'Status: Error'
  end
end;



//Every function takes argument from ArgVal and ArcCnt

function TfTest.AllTrim(Sender: TObject): variant;
begin
  if Expr.ArgCnt=0 then
    ShowMessage('AllTrim: Argument expected')
  else
    result := trim(VarAsType(Expr.ArgVal[0],VarString))
end;

function TfTest.Date(Sender: TObject): variant;
begin
  result := Sysutils.date
end;

function TfTest.at(Sender: TObject): variant;
begin
  if Expr.ArgCnt=0 then
    ShowMessage('Argument expected.  At(<string>,<string>)')
  else
    result := Pos(VarAsType(Expr.ArgVal[0],VarString), VarAsType(Expr.ArgVal[1],VarString))
end;

function TfTest.iif(Sender: TObject): variant;
begin
  if Expr.ArgCnt=0 then
    ShowMessage('Argument expected  if(<boolean>,<value>,<value>)')
  else if Expr.ArgVal[0] then
    result := Expr.ArgVal[1]
  else
    result := Expr.ArgVal[2]
end;

function TfTest.len(Sender: TObject): variant;
begin
  if Expr.ArgCnt=0 then
    ShowMessage('Len. Argument expected.  len(<string>)')
  else
    result := Length(VarAsType(Expr.ArgVal[0],VarString))
end;

function TfTest.time(Sender: TObject): variant;
begin
  result := Sysutils.time
end;


procedure TfTest.ExprRequestFunction(Sender: TObject; ident: String; var value: Variant;
  var cancel: Boolean);
var
  posi : integer;
begin
  posi :=  FnLst.GetFuncPos(ident);
  if posi>=0 then
    value := FnLst.FuncArray[posi](Self)
  else
    cancel := true;
end;

procedure TfTest.ExprRequestIdentifier(Sender: TObject; ident, alias: String;
  var value: Variant; var cancel: Boolean);
Var
  Posi : integer;
begin
// Alias implied field (sometimes)
  if alias>'' then
    begin
      Posi := DataSetLst.GetFldPos(alias +'.' + ident);
      if Posi<0 then
        cancel := true
      else
        value := TField(DataSetLst.FldArray[Posi]).AsVariant;
    end
  else
    begin
      Posi := DataSetLst.GetFldPos('country.' + ident);
      if Posi<0 then // no es campo
        begin
          if not IdLst.GetIdentValue(ident, value) then
            cancel := true;
        end
      else
        value := TField(DataSetLst.FldArray[Posi]).AsVariant;
    end;
end;

end.
